package com.zfire.jiasm.syncdata.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.StringUtils;
import com.zfire.jiasm.syncdata.constant.DictTypeEnum;
import com.zfire.jiasm.syncdata.constant.InterFaceTypeEnum;
import com.zfire.jiasm.syncdata.dao.mapper.OJTGUploadTaskListMapper;
import com.zfire.jiasm.syncdata.parameter.InstallUpdatePar;
import com.zfire.jiasm.syncdata.plus.entity.*;
import com.zfire.jiasm.syncdata.plus.service.*;
import com.zfire.jiasm.syncdata.response.SSQS;
import com.zfire.jiasm.syncdata.response.WebsitFWS;
import com.zfire.jiasm.syncdata.response.WebsitPP;
import com.zfire.jiasm.syncdata.response.WebsitSH;
import com.zfire.jiasm.syncdata.service.PublicService;
import io.swagger.annotations.ApiModelProperty;
import org.apache.commons.collections4.CollectionUtils;
import org.springframework.beans.BeanUtils;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.*;
import java.util.stream.Collectors;

@Service
public class PublicServiceImpl implements PublicService {
    @Resource
    OrderWorkerService orderWorkerService;
    @Resource
    SysDictRefService sysDictRefService;
    @Resource
    WebsitOrderSignService websitOrderSignService;
    @Resource
    CustomerInformationWebsitService customerInformationWebsitService;
    @Resource
    BrandWebsitService brandWebsitService;
    @Resource
    WebsitService websitService;
    @Resource
    OutJiasmToGreeUploadTaskListService outJiasmToGreeUploadTaskListService;
    @Resource
    OJTGUploadTaskListMapper ojtgUploadTaskListMapper;
    @Resource
    OrderRepairOperatingLogService orderRepairOperatingLogService;
    @Resource
    SysDictService sysDictService;
    @Resource
    WebsitServiceCategoryDetailService websitServiceCategoryDetailService;
    @Resource
    CustomerInformationService customerInformationService;
    @Resource
    StreetService streetService;
    @Resource
    BrandLbsRelateService brandLbsRelateService;
    @Resource
    AreaService areaService;
    @Resource
    WebsitSetupRegionService websitSetupRegionService;
    @Resource
    BrandService brandService;


    @Override
    public OrderWorker getOrderWorker(OrderBase orderBase){
        if (StringUtils.isNotEmpty(orderBase.getWorkerName())){
            OrderWorker orderWorker = new OrderWorker();
            orderWorker.setOrderBaseId(orderBase.getId());
            orderWorker.setWorkerId(orderBase.getWorkerId());
            orderWorker.setWorkerName(orderBase.getWorkerName());
            orderWorker.setWorkerMobile(orderBase.getWorkerMobile());
            orderWorker.setWorkerIdcard(orderBase.getWorkerIdcard());
            orderWorker.setIsMaster(Boolean.TRUE);
            orderWorker.setBrandPgid(orderBase.getPgid());
            orderWorker.setPgguid(orderBase.getPgguid());
            orderWorker.setCreateTime(orderBase.getCreateTime());
            orderWorker.setCreateBy(orderBase.getCreateBy());
            orderWorker.setOutWorkerSource(Boolean.FALSE);

            orderWorkerService.save(orderWorker);

            return orderWorker;
        }

        return null;
    }

    @Override
    public List<OrderWorker> getWorker(String workerId,String orderBaseId) {
        List<OrderWorker> ows = orderWorkerService.lambdaQuery()
                .eq(OrderWorker::getOrderBaseId,orderBaseId)
                .eq(OrderWorker::getOutWorkerSource,Boolean.FALSE).list();
        return ows;
    }

    @Override
    public void deleteWorker(String orderBaseId){
        QueryWrapper del = new QueryWrapper<OrderWorker>()
                .eq("order_base_id", orderBaseId);

        orderWorkerService.remove(del);
    }


    @Override
    public Map<String, List<SysDictRef>> getStringListMap(Brand brand){
        List<SysDictRef> sysDictRef;
        Map<String, List<SysDictRef>> sysDictRefDLMap = new HashMap<>();
        sysDictRef =  sysDictRefService.lambdaQuery()
                .select(SysDictRef::getDictCode,SysDictRef::getDictValue,SysDictRef::getRefDictCode)
                .eq(SysDictRef::getBrandId, brand.getBrandId())
                .eq(SysDictRef::getDictType, DictTypeEnum.DICT_TYPE_MAIN_TYPE.getCode())
                .list();
        sysDictRefDLMap = sysDictRef.stream().
                collect(Collectors.groupingBy(SysDictRef::getRefDictCode));
        return sysDictRefDLMap;
    }

    @Override
    public Map<String, List<SysDictRef>> getListMap(Brand brand){
        List<SysDictRef> sysDictxlRef;
        Map<String, List<SysDictRef>> sysDictRefXLMap = new HashMap<>();
        sysDictxlRef =  sysDictRefService.lambdaQuery()
                .select(SysDictRef::getDictCode,SysDictRef::getDictValue,SysDictRef::getRefDictCode)
                .eq(SysDictRef::getBrandId, brand.getBrandId())
                .eq(SysDictRef::getDictType, DictTypeEnum.DICT_TYPE_SMALL_TYPE.getCode())
                .list();
        sysDictRefXLMap = sysDictxlRef.stream().
                collect(Collectors.groupingBy(SysDictRef::getRefDictCode));
        return sysDictRefXLMap;
    }

    @Override
    public Map<String, List<SysDictRef>> getMap(Brand brand){
        List<SysDictRef> sysDictxilieRef;
        Map<String, List<SysDictRef>> sysDictRefXiLieMap = new HashMap<>();
        sysDictxilieRef =  sysDictRefService.lambdaQuery()
                .select(SysDictRef::getDictCode,SysDictRef::getDictValue,SysDictRef::getRefDictCode)
                .eq(SysDictRef::getBrandId, brand.getBrandId())
                .eq(SysDictRef::getDictType, DictTypeEnum.DICT_TYPE_SERIES.getCode())
                .list();
        sysDictRefXiLieMap = sysDictxilieRef.stream().
                collect(Collectors.groupingBy(SysDictRef::getRefDictCode));
        return sysDictRefXiLieMap;
    }


    @Override
    public Map<String, List<SysDictRef>> getStringListMapXq(Brand brand){
        List<SysDictRef> sysDictRef;
        Map<String, List<SysDictRef>> sysDictRefDLMap = new HashMap<>();
        sysDictRef =  sysDictRefService.lambdaQuery()
                .select(SysDictRef::getDictCode,SysDictRef::getDictValue,SysDictRef::getRefDictCode)
                .eq(SysDictRef::getBrandId, brand.getBrandId())
                .eq(SysDictRef::getDictType, DictTypeEnum.DICT_TYPE_DEMAND_TYPE.getCode())
                .list();
        sysDictRefDLMap = sysDictRef.stream().
                collect(Collectors.groupingBy(SysDictRef::getRefDictCode));
        return sysDictRefDLMap;
    }

    @Override
    public Map<String, List<SysDictRef>> getListMapXq(Brand brand){
        List<SysDictRef> sysDictxlRef;
        Map<String, List<SysDictRef>> sysDictRefXLMap = new HashMap<>();
        sysDictxlRef =  sysDictRefService.lambdaQuery()
                .select(SysDictRef::getDictCode,SysDictRef::getDictValue,SysDictRef::getRefDictCode)
                .eq(SysDictRef::getBrandId, brand.getBrandId())
                .eq(SysDictRef::getDictType, DictTypeEnum.DICT_TYPE_DEMAND_SMALL_TYPE.getCode())
                .list();
        sysDictRefXLMap = sysDictxlRef.stream().
                collect(Collectors.groupingBy(SysDictRef::getRefDictCode));
        return sysDictRefXLMap;
    }

    // 提取品牌商对应的需求小类信息
    @Override
    public Map<String, List<SysDictRef>> getListMapXqtoPP(Brand brand){
        List<SysDictRef> sysDictxlRef;
        Map<String, List<SysDictRef>> sysDictRefXLMap = new HashMap<>();
        sysDictxlRef =  sysDictRefService.lambdaQuery()
                .select(SysDictRef::getDictCode,SysDictRef::getDictValue,SysDictRef::getRefDictCode)
                .eq(SysDictRef::getBrandId, brand.getBrandId())
                .eq(SysDictRef::getDictType, DictTypeEnum.DICT_TYPE_DEMAND_SMALL_TYPE.getCode())
                .list();
        sysDictRefXLMap = sysDictxlRef.stream().
                collect(Collectors.groupingBy(SysDictRef::getDictCode));
        return sysDictRefXLMap;
    }

    // 提取品牌商对应的需求类别信息
    @Override
    public Map<String, List<SysDict>> getStringListMapXqLb(){
        Map<String, List<SysDict>> result = new HashMap<>();

        List<SysDict> sysDictxl = sysDictService.lambdaQuery()
                .select(SysDict::getDictCode,SysDict::getDictValue)
                .eq(SysDict::getDictType, DictTypeEnum.DICT_TYPE_DEMAND_ASK_CATEGORY.getCode())
                .list();

        result = sysDictxl.stream().
                collect(Collectors.groupingBy(SysDict::getDictCode));
        return result;
    }



    @Override
    public String getSHWDPhone(String websitNo){
        Websit websit = websitService.lambdaQuery()
                .eq(Websit::getWebsitId,websitNo)
                .one();
        if (websit != null){
            if (StringUtils.isNotEmpty(websit.getHotline())){
                return websit.getHotline();
            } else if (StringUtils.isNotEmpty(websit.getOfficePhone()))
                return websit.getOfficePhone();
        }
        return "";
    }

    private WebsitFWS WebsitToSH(String websitNo, String brandId){
        WebsitFWS resultData = new WebsitFWS();

        resultData.setWdId("");
        resultData.setWdmc("");
        resultData.setWdlxdh("");

        // 先从售后网点查
        WebsitOrderSign wos = websitOrderSignService.lambdaQuery()
                .eq(WebsitOrderSign::getBrandWebsitId, websitNo)
                .eq(WebsitOrderSign::getBrandId, brandId)
                .one();
        if (wos != null){
            resultData.setWdId(wos.getWebsitId());
        } else {
            CustomerInformationWebsit ciwx = customerInformationWebsitService.lambdaQuery()
                    .eq(CustomerInformationWebsit::getRefWebsitId, websitNo)
                    .eq(CustomerInformationWebsit::getBrandId, brandId)
                    .one();
            if (ciwx !=null){
                resultData.setWdId(ciwx.getWebsitId());
            }
        }

        // 提取网点名称
        if (StringUtils.isNotEmpty(resultData.getWdId())){
            Websit websit = websitService.lambdaQuery()
                    .eq(Websit::getWebsitId,resultData.getWdId())
                    .one();
            if (websit != null){
                resultData.setWdmc(websit.getWebsitName());
                if (StringUtils.isNotEmpty(websit.getHotline())){
                    resultData.setWdlxdh(websit.getHotline());
                } else if (StringUtils.isNotEmpty(websit.getOfficePhone()))
                    resultData.setWdlxdh(websit.getOfficePhone());
            }
        }

        return resultData;
    }

    // 商户网点对应品牌网点
    private WebsitPP WebsitToPP(String websitId, String brandId){
        WebsitPP resultData = new WebsitPP();

        resultData.setXtwdno("");
        resultData.setWdno("");
        resultData.setWdmc("");

        // 先从售后网点查
        WebsitOrderSign wos = websitOrderSignService.lambdaQuery()
                .eq(WebsitOrderSign::getWebsitId, websitId)
                .eq(WebsitOrderSign::getBrandId, brandId)
                .one();
        if (wos != null){
            resultData.setWdno(wos.getBrandWebsitId());
            resultData.setWdmc(wos.getBrandWebsitName());
        } else {
            // 查看销售网点
            CustomerInformationWebsit ciwx = customerInformationWebsitService.lambdaQuery()
                    .eq(CustomerInformationWebsit::getWebsitId, websitId)
                    .eq(CustomerInformationWebsit::getBrandId, brandId)
                    .one();
            if (ciwx !=null){
                resultData.setWdno(ciwx.getRefWebsitId());
                resultData.setWdmc(ciwx.getRefWebsitName());
            }
        }

        // 提取系统网点编号
        if (StringUtils.isNotEmpty(resultData.getWdno())){
            BrandWebsit bw = brandWebsitService.lambdaQuery()
                    .eq(BrandWebsit::getBrandWebsitNumber, resultData.getWdno())
                    .eq(BrandWebsit::getGroupCompanyId, brandId)
                    .one();
            if (bw != null){
                resultData.setXtwdno(bw.getSysWebsitNumber());
            }

        }

        return resultData;
    }


    @Override
    public OutJiasmToGreeUploadTaskList getUploadTaskListLog(String orderNo, String id, Date updateTime,
                                                             String itemTableName, String itemOrderType, int taskType) {
        // 提取目志的类型
        OrderRepairOperatingLog rlog = orderRepairOperatingLogService.lambdaQuery()
                .eq(OrderRepairOperatingLog::getId,id).one();

        OutJiasmToGreeUploadTaskList add = new OutJiasmToGreeUploadTaskList();
        add.setUploadTaskType(taskType);
        add.setOrderNo(orderNo);
        add.setId(id);
        add.setTaskExtraInfo(rlog.getType());
        add.setTableName(itemTableName);
        add.setOrderType(itemOrderType);
        add.setSynReqTime(new Date());
        add.setUpdatetime(updateTime);
        return add;
    }

    @Override
    public OutJiasmToGreeUploadTaskList getUploadTaskList(String orderNo, String id, Date updateTime,
                                                          String itemTableName, String itemOrderType, int taskType) {
        OutJiasmToGreeUploadTaskList add = new OutJiasmToGreeUploadTaskList();
        add.setUploadTaskType(taskType);
        add.setOrderNo(orderNo);
        add.setId(id);
        add.setTableName(itemTableName);
        add.setOrderType(itemOrderType);
        add.setSynReqTime(new Date());
        add.setUpdatetime(updateTime);
        return add;
    }

    @Override
    public OutJiasmToGreeUploadTaskList getUploadTaskList(String orderNo, String id,
                                                          String itemTableName, String itemOrderType, int taskType) {
        OutJiasmToGreeUploadTaskList add = new OutJiasmToGreeUploadTaskList();
        add.setUploadTaskType(taskType);
        add.setOrderNo(orderNo);
        add.setId(id);
        add.setTableName(itemTableName);
        add.setOrderType(itemOrderType);
        add.setSynReqTime(new Date());
        return add;
    }

    @Override
    public String getfsma() {
        Random random = new Random(System.currentTimeMillis());
        String fsma = String.valueOf(random.nextInt(10000));

        if (fsma.length()<4){
            if (fsma.length()==3){
                fsma = fsma + "9";
            } else if (fsma.length()==2){
                fsma = fsma + "99";
            } else {
                fsma = fsma + "`999";
            }
        }
        return fsma;
    }

    @Override
    public void updateUploadTaskListStatus(String orderNo, Long synReqId,Integer synStatus,Integer uploadTaskType){
        OutJiasmToGreeUploadTaskList upoutgultl = new OutJiasmToGreeUploadTaskList();
        upoutgultl.setSynReqId(synReqId);
        upoutgultl.setSynStatus(synStatus);
        upoutgultl.setSynTime(new Date());
        outJiasmToGreeUploadTaskListService.updateById(upoutgultl);

        // 批量修改
        InstallUpdatePar request = new InstallUpdatePar();
        request.setOrderNo(orderNo);
        request.setUploadTaskType(uploadTaskType);
        request.setSynReqId(synReqId);
        ojtgUploadTaskListMapper.installUpdateuploadTaskList(request);
    }

    @Override
    public void updateUploadTaskLisError(OutJiasmToGreeUploadTaskList ojtutl, String msg){
        ojtutl.setSynTime(new Date());
        if (msg.length()>255){
            ojtutl.setSynErrMsg(msg.substring(0,255));
        } else {
            ojtutl.setSynErrMsg(msg);
        }
        ojtutl.updateById();
    }

    /**
     * 商户网点信息
     * @param websitNo  商户网点编号
     * @param type      商户网点类型(销售或售后)
     */
    @Override
    public WebsitSH merchantWebsitInfoX(String websitNo,String type){
        WebsitSH resultData = new WebsitSH();
        // 提取格力集团信息
        Brand brandRec = brandService.lambdaQuery().eq(Brand::getBrand,"格力").one();

        if (StringUtils.isEmpty(websitNo)){
            return resultData;
        }

        BrandWebsit brandWebsit = brandWebsitService.lambdaQuery()
                .eq(BrandWebsit::getGroupCompanyId,brandRec.getBrandId())
                .eq(BrandWebsit::getType,type)
                .eq(BrandWebsit::getBrandWebsitNumber,websitNo).one();

        if (brandWebsit !=null){
            resultData.setWdId(brandWebsit.getBrandWebsitNumber());
            resultData.setWdmc(brandWebsit.getBrandWebsitName());
            resultData.setBrandSysWebsitNumber(brandWebsit.getSysWebsitNumber());
        }

        return resultData;
    }


    /**
     * 商户销售网点对应平台销售网点
     * @param websitNo  商户销售网点编号
     * @param category  商户工单类别
     * @return
     */
    @Override
    public WebsitFWS shxswdToptxswd(String websitNo, String category){
        WebsitFWS resultData = new WebsitFWS();
        if (StringUtils.isEmpty(websitNo)){
            return resultData;
        }
        // 提取平台的销售网点信息 无信息不处理
        List<CustomerInformationWebsit> cIWebsitList = customerInformationWebsitService.lambdaQuery()
                .eq(CustomerInformationWebsit::getRefWebsitId,websitNo).list();
        if (CollectionUtils.isNotEmpty(cIWebsitList)){
            if (cIWebsitList.size()==1){
                resultData.setWdId(cIWebsitList.get(0).getWebsitId());
                resultData.setBrandSysWebsitNumber(cIWebsitList.get(0).getRefSysWebsitNumber());
                getNameAndHotline(resultData);
                return resultData;
            }
            // 看服务商销售网点是否服务工单大类 不会存在多个，找到即返回
            for (CustomerInformationWebsit item:cIWebsitList){
                WebsitServiceCategoryDetail wosinfo = getWebCategory(item.getBrandId(),item.getWebsitId(),category);
                if (wosinfo !=null){
                    resultData.setWdId(item.getWebsitId());
                    getNameAndHotline(resultData);
                    resultData.setBrandSysWebsitNumber(item.getRefSysWebsitNumber());
                    break;
                }
            }
        }
        return resultData;
    }

    /**
     * 商户售后网点对应平台售后网点
     * @param websitNo  商户售后网点编号
     * @param category 商户工单数据
     * @return
     */
   @Override
   public WebsitFWS shshwdToptshwd(String websitNo, String category){
       WebsitFWS resultData = new WebsitFWS();
       if (StringUtils.isEmpty(websitNo)){
           return resultData;
       }

       // 提取商户售后网点对应的平台售后网点信息 存在一对多的关系
       List<WebsitOrderSign> wos = getWebsitOrderSign(websitNo);
       if (CollectionUtils.isNotEmpty(wos)){
           // 找到一条记录时取网点名称直接返回
           if (wos.size() == 1){
               resultData.setWdId(wos.get(0).getWebsitId());
               getNameAndHotline(resultData);
               resultData.setBrandSysWebsitNumber(wos.get(0).getBrandSysWebsitNumber());
               resultData.setBrandId(wos.get(0).getBrandId());
               resultData.setBrandName(wos.get(0).getBrandName());
               return resultData;
           }
           // 多记录时根据网点服务的产品大类是否满足订单的大类(category) 进行取舍
           WebsitOrderSign wost = websitCategory(wos, category);
           // 无对应关系先工单落表，不再对应
           if (wost != null){
               resultData.setWdId(wost.getWebsitId());
               getNameAndHotline(resultData);
               resultData.setBrandSysWebsitNumber(wost.getBrandSysWebsitNumber());
               resultData.setBrandId(wos.get(0).getBrandId());
               resultData.setBrandName(wos.get(0).getBrandName());
           }
       }
       return resultData;
   }

    /**
     * 平台销售网点对应商户销售网点
     * @param websitNo  平台销售网点编号
     * @param category  工单类别
     * @return
     */
    @Override
    public WebsitSH ptxswdToshxswd(String websitNo, String category){
        WebsitSH resultData = new WebsitSH();
        if (StringUtils.isEmpty(websitNo)){
            return resultData;
        }

        // 提取平台的销售网点信息 无信息不处理
        List<CustomerInformationWebsit> cIWebsitList = customerInformationWebsitService.lambdaQuery()
                .eq(CustomerInformationWebsit::getWebsitId,websitNo).list();
        if (CollectionUtils.isNotEmpty(cIWebsitList)){
            if (cIWebsitList.size()==1){
                return merchantWebsitInfoX(cIWebsitList.get(0).getRefWebsitId(),
                        InterFaceTypeEnum.XS_WEBSIT_TYPE.getCode());
            }
            // 看商户销售网点是否服务工单大类,找到即返回
            for (CustomerInformationWebsit item:cIWebsitList) {
                BrandWebsit bw = brandWebsitService.lambdaQuery()
                        .eq(BrandWebsit::getGroupCompanyId, item.getGroupCompanyId())
                        .eq(BrandWebsit::getSplb,category)
                        .eq(BrandWebsit::getBrandWebsitNumber, item.getRefWebsitId())
                        .one();
                if (bw != null) {
                    return merchantWebsitInfoX(bw.getBrandWebsitNumber(),
                            InterFaceTypeEnum.XS_WEBSIT_TYPE.getCode());
                }
            }
        }

        return resultData;
    }

    /**
     * 平台售后网点对应商户售后网点
     * @param websitNo  平台售后网点编号
     * @param category  工单
     * @return
     */
    @Override
    public WebsitSH  ptshwdToshshwd(String websitNo, String category) {
        WebsitSH resultData = new WebsitSH();
        List<BrandWebsit> wosn = new ArrayList<>();

        if (StringUtils.isEmpty(websitNo)) {
            return resultData;
        }

        // 提取平台售后网点对应的商户售后网点信息 存在一对多的关系
        List<WebsitOrderSign> wos = new ArrayList<>();
        wos = websitOrderSignService.lambdaQuery()
                .eq(WebsitOrderSign::getWebsitId, websitNo)
                .list();

        if (CollectionUtils.isNotEmpty(wos)) {
            // 找到一条记录时直接返回
            if (wos.size() == 1) {
                return merchantWebsitInfoX(wos.get(0).getBrandWebsitId(),
                        InterFaceTypeEnum.SH_WEBSIT_TYPE.getCode());
            }

            // 多记录时根据商户网点服务的产品大类是否满足订单的大类(category) 进行取舍
            for (WebsitOrderSign item : wos) {
                BrandWebsit bw = brandWebsitService.lambdaQuery()
                        .eq(BrandWebsit::getSplb, category)
                        .eq(BrandWebsit::getBrandWebsitNumber, item.getBrandWebsitId())
                        .one();
                if (bw != null) {
                    wosn.add(bw);
                }
            }
            // 这里一般是存在的
            if (wosn.size() == 0) {
                return resultData;
            }

            // 已做限制 同一个大类不会归属两个以上服务网点
            return merchantWebsitInfoX(wosn.get(0).getBrandWebsitNumber(),
                    InterFaceTypeEnum.SH_WEBSIT_TYPE.getCode());
        }

        return resultData;
    }








    // 平台网点服务的大类信息
    private WebsitOrderSign websitCategory(List<WebsitOrderSign> wos, String categoryId){
        // 这里的wos会存在多总包商户信息
        // Map<String, List<WebsitOrderSign>> wosMap = new HashMap<>();
        List<WebsitOrderSign> wosn = new ArrayList<>();
        List<WebsitOrderSign> wosnn = new ArrayList<>();
        // 对应多总包服务商 处理方式与一个总包服务商相同
        // 一个总包服务商多网点：从平台网点服务的类目取对应的网点信息 一般在这里就可以区分开
        for (WebsitOrderSign item:wos){
            WebsitServiceCategoryDetail wosinfo = getWebCategory(item.getBrandId(),item.getWebsitId(), categoryId);
            if (wosinfo !=null){
                wosn.add(item);
            }
        }
        if (wosn.size() ==0 ){
            return null;
        }
        // 已做限制 同一个大类不会归属两个以上服务网点
        return wosn.get(0);

    }

    // 多网点时 从网点所在区域过滤
    private void getWebsitInfo(OrderBase orderBase, List<WebsitOrderSign> wosn, List<WebsitOrderSign> wosnn) {
        // 提取商户工单网点的省市区街道ID 这里为平台的省市区街道ID
        SSQS result = getOrderBasePosition(orderBase);
        // 提取位置对应的平台网点信息
        for (WebsitOrderSign item: wosn){
            List<WebsitSetupRegion> customerInformation = websitSetupRegionService.lambdaQuery()
                    .eq(WebsitSetupRegion::getBrandId,item.getBrandId())
                    .eq(WebsitSetupRegion::getWebsitId,item.getWebsitId()).list();
            for (WebsitSetupRegion i:customerInformation){
                if (i.getProvinceId().equals(result.getProvinceId()) &&
                        i.getCityId().equals(result.getCityId()) &&
                        i.getAreaId().equals(result.getAreaId()) &&
                        i.getStreetId().equals(result.getStreetId())){
                    wosnn.add(item);
                }
            }
        }
    }

    // 获取网点对应的 省市区街道ID
    private SSQS getOrderBasePosition(OrderBase orderBase){
        SSQS result = new SSQS();
        getPCAS(orderBase,result);

        return result;
    }

    // 获取网点对应的 省市区街道ID
    private SSQS getPosition(OrderBase orderBase){
        SSQS result = new SSQS();
        getPCAS(orderBase,result);

        return result;
    }



    private void getPCAS(OrderBase orderBase,SSQS result) {
        List<BrandLbsRelate> br;
        if (StringUtils.isNotEmpty(orderBase.getStreet())){
            Street street = streetService.lambdaQuery()
                    .eq(Street::getProvince, orderBase.getProvince())
                    .eq(Street::getCity, orderBase.getCity())
                    .eq(Street::getArea, orderBase.getArea())
                    .eq(Street::getStreet, orderBase.getStreet()).one();
            getPCA(result, street);
            //街道
            br = brandLbsRelateService.lambdaQuery()
                    .eq(BrandLbsRelate::getStreetId,street.getStreetId())
                    .isNotNull(BrandLbsRelate::getLbsDistrictId).list();
            if (br !=null && br.size()>0){
                result.setStreetId(br.get(0).getLbsStreetId());
            }
        } else {
            // 总部区必选
            Area area = areaService.lambdaQuery()
                    .eq(Area::getArea, orderBase.getArea()).one();
            Street st = new Street();
            if (area !=null){
                BeanUtils.copyProperties(area,st);
                getPCA(result, st);
            }
        }
    }

    private void getPCA(SSQS result, Street street) {
        List<BrandLbsRelate> br;
        //省
        br = brandLbsRelateService.lambdaQuery()
                .eq(BrandLbsRelate::getProvinceId, street.getProvinceId())
                .isNotNull(BrandLbsRelate::getLbsProvinceId).list();
        if (br !=null && br.size()>0){
            result.setProvinceId(br.get(0).getLbsProvinceId());
        }
        //市
        br = brandLbsRelateService.lambdaQuery()
                .eq(BrandLbsRelate::getCityId, street.getCityId())
                .isNotNull(BrandLbsRelate::getLbsCityId).list();
        if (br !=null && br.size()>0){
            result.setCityId(br.get(0).getLbsCityId());
        }
        //区
        br = brandLbsRelateService.lambdaQuery()
                .eq(BrandLbsRelate::getAreaId, street.getAreaId())
                .isNotNull(BrandLbsRelate::getLbsDistrictId).list();
        if (br !=null && br.size()>0){
            result.setAreaId(br.get(0).getLbsDistrictId());
        }
    }

    // 平台网点与其服务的大类 商户ID，商户网点，网点服务的大类
    private WebsitServiceCategoryDetail getWebCategory(String brandId,String websitId,String categoryId){
        // 查看平台网点是否服务该类目 不存在即找到的网点不接该服务类型的工单
        return websitServiceCategoryDetailService.lambdaQuery()
                .eq(WebsitServiceCategoryDetail::getBrandId,brandId)
                .eq(WebsitServiceCategoryDetail::getWebsitId,websitId)
                .eq(WebsitServiceCategoryDetail::getMainId,categoryId).one();
    }








    // 获取商户销售网点对应的平台服务商的网点信息 存在一对多的关系
    private List<WebsitOrderSign> ppxswdToptxswd(String ppWebsitNo, String brandId){
        List<WebsitOrderSign> wos = new ArrayList<>();
        wos = websitOrderSignService.lambdaQuery()
                .eq(WebsitOrderSign::getBrandWebsitId, ppWebsitNo)
                .eq(WebsitOrderSign::getBrandId, brandId)
                .list();
        return wos;
    }

    // 提取平台网点名称及服务热线
    private  void getNameAndHotline(WebsitFWS req){
        Websit websit = websitService.lambdaQuery()
                .eq(Websit::getWebsitId,req.getWdId()).one();

        if (websit != null){
            if (StringUtils.isNotEmpty(websit.getHotline())){
                req.setWdlxdh(websit.getHotline());
            } else if (StringUtils.isNotEmpty(websit.getOfficePhone())){
                req.setWdlxdh(websit.getOfficePhone());
            }
            if (StringUtils.isNotEmpty(websit.getWebsitName())){
                req.setWdmc(websit.getWebsitName());
            }
        }
    }

    private List<WebsitOrderSign> getWebsitOrderSign(String ppWebsitNo){
        List<WebsitOrderSign> wos = new ArrayList<>();
        wos = websitOrderSignService.lambdaQuery()
                .eq(WebsitOrderSign::getBrandWebsitId, ppWebsitNo)
                .list();
        return wos;
    }


}
